---
include:
  project: tpo/web/onion-mkdocs
  file: .gitlab-ci-base.yml

stages:
  - build
  - docs

.base:
  before_script:
    # Install basic dependencies
    - apt update
    - apt install -y sudo git make #mkcert
  after_script:
    # Configure a demo
    # Output the config log either on success or failure
    - err=0
    - ./onionspray config examples/tpo.tconf || err=1
    - ./onionspray config examples/softexample.tconf || err=1
    - cat log/configure*.log
    - exit $err

lint:
  image: debian:bookworm-backports
  stage: build
  script:
    - apt update
    - apt install -y make
    - make lint

#bullseye:
#  image: debian:bullseye-backports
#  stage: build
#  extends: .base
#  script:
#    # Build dependencies from sources
#    - ./opt/build-debian-bullseye.sh

bookworm:
  image: debian:bookworm-backports
  stage: build
  extends: .base
  script:
    # Build dependencies from sources
    #- ./opt/build-debian-bookworm.sh

    # Install dependencies from packages
    - ./opt/install-debian-bookworm.sh

#focal:
#  image: ubuntu:focal
#  stage: build
#  extends: .base
#  script:
#    # Build dependencies from sources
#    - ./opt/build-ubuntu-20.04.sh

#jammy:
#  image: ubuntu:jammy
#  stage: build
#  extends: .base
#  script:
#    # Build dependencies from sources
#    #- ./opt/build-ubuntu-22.04.sh
#
#    # Install dependencies from packages
#    - ./opt/install-ubuntu-22.04.sh

noble:
  image: ubuntu:noble
  stage: build
  extends: .base
  script:
    # Build dependencies from sources
    - ./opt/build-ubuntu-24.04.sh

    # Install dependencies from packages
    #- ./opt/install-ubuntu-24.04.sh

pages:
  stage: docs
  extends: .onion-mkdocs-clone

release:
  image: registry.gitlab.com/gitlab-org/release-cli:latest
  stage: .post
  rules:
    # Run this job when a tag is created
    - if: $CI_COMMIT_TAG
  script:
    - echo "Running release_job..."
  release:
    tag_name: '$CI_COMMIT_TAG'
    description: '$CI_COMMIT_TAG'
